=== debian/changelog ===
codelite (18.2.0-2unofficial.trixie) stable; urgency=low

  * Add libpcre2-32-0 to 'Depends'.
  * See https://github.com/eranif/codelite/issues/3762

 -- David Hart <david@codelite.co.uk>  Wed, 05 Nov 2025 10:41:23 +0000

codelite (18.2.0-1unofficial.trixie) stable; urgency=low

  * Update for the 18.2.0 release

 -- David Hart <david@codelite.co.uk>  Wed, 05 Nov 2025 10:41:23 +0000

codelite (18.1-1unofficial.bookworm) stable; urgency=low

  * Update for the 18.1 release

 -- David Hart <david@codelite.co.uk>  Sat, 18 Jan 2025 10:36:59 +0000
